| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 1 | #!/usr/bin/env bash |
| 2 | |
| 3 | ## |
| 4 | # Copyright 2020 ATOS |
| 5 | # |
| 6 | # All Rights Reserved. |
| 7 | # |
| 8 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 9 | # you may not use this file except in compliance with the License. |
| 10 | # You may obtain a copy of the License at |
| 11 | # |
| 12 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 13 | # |
| 14 | # Unless required by applicable law or agreed to in writing, software |
| 15 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 16 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 17 | # See the License for the specific language governing permissions and |
| 18 | # limitations under the License. |
| 19 | ## |
| 20 | |
| 21 | cat /dev/zero | ssh-keygen -q -N "" > /dev/null |
| 22 | |
| 23 | install_osmclient(){ |
| 24 | echo -e "\nInstalling osmclient ${OSMCLIENT}" |
| 25 | python3 -m pip install git+https://osm.etsi.org/gerrit/osm/osmclient@${OSMCLIENT} |
| 26 | } |
| 27 | |
| 28 | download_packages(){ |
| 29 | echo -e "\nDownloading packages ${PACKAGES}" |
| 30 | rm -rf ${PACKAGES_FOLDER} |
| garciadeblas | 28ce11e | 2021-03-02 16:15:17 +0000 | [diff] [blame] | 31 | git clone https://osm.etsi.org/gitlab/vnf-onboarding/osm-packages.git ${PACKAGES_FOLDER} |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 32 | } |
| 33 | |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 34 | download_tst010(){ |
| 35 | # Fetch conformance tests |
| 36 | git clone --single-branch --branch ${NFV_TESTS_BRANCH} https://forge.etsi.org/rep/nfv/api-tests.git /robot-systest/conformance-tests/repo |
| veleza | 12ed0f5 | 2021-12-07 08:29:34 +0000 | [diff] [blame] | 37 | #python3 -m pip install -r /robot-systest/conformance-tests/repo/requirements.txt |
| 38 | python3 -m pip install -r /robot-systest/conformance-tests/requirements.txt |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 39 | } |
| 40 | |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 41 | |
| Mark Beierl | 9e36736 | 2022-12-09 10:20:45 -0500 | [diff] [blame] | 42 | create_k8scluster(){ |
| 43 | attempts=3 |
| 44 | while [ $attempts -ge 0 ] ; do |
| 45 | echo -e "\n$( date '+%F_%H:%M:%S' ) Creating K8s Cluster" |
| 46 | |
| Mark Beierl | ef4e1f2 | 2022-12-15 15:55:24 -0500 | [diff] [blame] | 47 | osm k8scluster-add --creds ${K8S_CREDENTIALS} --version "v1" --vim ${VIM_TARGET} --k8s-nets "{\"net1\": \"${VIM_MGMT_NET}\"}" ${VIM_TARGET} --description "Robot cluster" |
| Mark Beierl | 9e36736 | 2022-12-09 10:20:45 -0500 | [diff] [blame] | 48 | |
| 49 | STATUS="" |
| 50 | i=0 |
| 51 | while [[ ${STATUS} != "ENABLED" ]] |
| 52 | do |
| 53 | ((i++)) |
| 54 | if [[ $i -eq 5 ]]; then |
| 55 | echo "K8s cluster stuck for more than 50 seconds:" |
| 56 | osm k8scluster-show ${VIM_TARGET} |
| 57 | osm k8scluster-delete ${VIM_TARGET} |
| 58 | sleep 5 |
| 59 | break |
| 60 | fi |
| 61 | sleep 10 |
| 62 | STATUS=`osm k8scluster-list | grep ${VIM_TARGET} | awk '{print $8}'` |
| 63 | done |
| 64 | if [[ ${STATUS} = "ENABLED" ]] ; then |
| 65 | break |
| 66 | fi |
| 67 | ((attempts--)) |
| 68 | done |
| 69 | if [ $attempts -lt 0 ] ; then |
| garciadeblas | c753f67 | 2023-05-18 15:06:49 +0200 | [diff] [blame] | 70 | echo "K8s cluster failed to enter ENABLED state" |
| Mark Beierl | 9e36736 | 2022-12-09 10:20:45 -0500 | [diff] [blame] | 71 | exit 1 |
| 72 | fi |
| 73 | } |
| 74 | |
| 75 | create_vim(){ |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 76 | attempts=3 |
| 77 | while [ $attempts -ge 0 ] ; do |
| 78 | echo -e "\n$( date '+%F_%H:%M:%S' ) Creating VIM ${VIM_TARGET}" |
| 79 | osm vim-create --name ${VIM_TARGET} --user ${OS_USERNAME} --password ${OS_PASSWORD} --tenant ${OS_PROJECT_NAME} \ |
| 80 | --auth_url ${OS_AUTH_URL} --account_type openstack --description vim \ |
| 81 | --config "{management_network_name: ${VIM_MGMT_NET}, dataplane_physical_net: ${DATAPLANE:-physnet2}}" || true |
| beierlm | 6cc2bd1 | 2020-12-03 11:44:47 -0500 | [diff] [blame] | 82 | STATUS="" |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 83 | i=0 |
| 84 | while [[ ${STATUS} != "ENABLED" ]] |
| 85 | do |
| 86 | ((i++)) |
| 87 | if [[ $i -eq 5 ]]; then |
| beierlm | 6cc2bd1 | 2020-12-03 11:44:47 -0500 | [diff] [blame] | 88 | echo "VIM stuck for more than 50 seconds as: ${VIM_LIST}" |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 89 | osm vim-delete --force ${VIM_TARGET} |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 90 | sleep 5 |
| 91 | break |
| 92 | fi |
| 93 | sleep 10 |
| beierlm | 1d535af | 2020-12-03 09:28:28 -0500 | [diff] [blame] | 94 | VIM_LIST=`osm vim-list --long | grep ${VIM_TARGET}` |
| 95 | echo VIM status: ${VIM_LIST} |
| beierlm | 6cc2bd1 | 2020-12-03 11:44:47 -0500 | [diff] [blame] | 96 | STATUS=`echo ${VIM_LIST} | grep -io ENABLED` |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 97 | done |
| 98 | if [[ ${STATUS} = "ENABLED" ]] ; then |
| 99 | break |
| Felipe Vicens | 02300c0 | 2020-07-02 12:19:28 +0200 | [diff] [blame] | 100 | fi |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 101 | ((attempts--)) |
| Felipe Vicens | 02300c0 | 2020-07-02 12:19:28 +0200 | [diff] [blame] | 102 | done |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 103 | if [ $attempts -lt 0 ] ; then |
| 104 | echo "VIM failed to enter ENABLED state" |
| 105 | exit 1 |
| 106 | fi |
| garciadeblas | 419af64 | 2021-04-14 16:45:24 +0200 | [diff] [blame] | 107 | if [ -n "${SDNC_URL}" ]; then |
| 108 | osm sdnc-create --name sdnc-osm --type ${SDNC_TYPE} --user ${SDNC_USER} --password ${SDNC_PASSWORD} --url ${SDNC_URL} |
| 109 | COUNTER=0 |
| 110 | STATUS="" |
| 111 | while [ ${COUNTER} -lt 5 ] ; do |
| 112 | echo "Checking status of SDNC sdnc-osm to see if it is enabled" |
| 113 | STATUS=$(osm sdnc-show sdnc-osm |grep -io ENABLED) |
| 114 | if [ "${STATUS}" == "ENABLED" ]; then |
| 115 | break |
| 116 | fi |
| 117 | ((COUNTER++)) |
| 118 | sleep 10 |
| 119 | done |
| 120 | if [ "${STATUS}" == "ENABLED" ]; then |
| 121 | echo "SDNC enabled" |
| 122 | else |
| 123 | echo "SDNC failed to enter ENABLED state" |
| 124 | osm sdnc-show sdnc-osm |
| 125 | exit 1 |
| 126 | fi |
| 127 | if [ -f /root/port-mapping.yaml ]; then |
| 128 | osm vim-update ${VIM_TARGET} --sdn_controller sdnc-osm --sdn_port_mapping /root/port-mapping.yaml |
| 129 | COUNTER2=0 |
| 130 | RESULT="" |
| 131 | while [ ${COUNTER2} -lt 5 ] ; do |
| 132 | echo "Checking status of VIM $VIM_TARGET to see if there is port-mapping" |
| 133 | osm vim-show $VIM_TARGET |grep sdn-port-mapping |
| 134 | if [ $? -eq 0 ]; then |
| 135 | RESULT="OK" |
| 136 | break |
| 137 | fi |
| 138 | ((COUNTER2++)) |
| 139 | sleep 10 |
| 140 | done |
| 141 | if [ "${RESULT}" == "OK" ]; then |
| 142 | echo "Port-mapping correctly added" |
| 143 | else |
| 144 | echo "Port-mapping failed to be added" |
| 145 | osm vim-show ${VIM_TARGET} |
| 146 | exit 1 |
| 147 | fi |
| 148 | fi |
| 149 | fi |
| Felipe Vicens | 55b6158 | 2020-06-24 21:23:44 +0200 | [diff] [blame] | 150 | } |
| 151 | |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 152 | |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 153 | PARAMS="" |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 154 | RUN_CONFORMANCE_TESTS=false |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 155 | |
| 156 | while (( "$#" )); do |
| 157 | case "$1" in |
| 158 | -t|--testingtags) |
| 159 | TEST=$2 |
| 160 | shift 2 |
| 161 | ;; |
| 162 | -p|--packagesbranch) |
| 163 | PACKAGES=$2 && download_packages |
| 164 | shift 2 |
| 165 | ;; |
| 166 | -o|--osmclientversion) |
| Felipe Vicens | 24e3d15 | 2020-06-25 21:52:06 +0200 | [diff] [blame] | 167 | OSMCLIENT=$2 && install_osmclient |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 168 | shift 2 |
| 169 | ;; |
| Felipe Vicens | 55b6158 | 2020-06-24 21:23:44 +0200 | [diff] [blame] | 170 | -c|--createvim) |
| 171 | create_vim |
| Mark Beierl | 9e36736 | 2022-12-09 10:20:45 -0500 | [diff] [blame] | 172 | create_k8scluster |
| Felipe Vicens | 55b6158 | 2020-06-24 21:23:44 +0200 | [diff] [blame] | 173 | shift 1 |
| 174 | ;; |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 175 | -T) |
| 176 | NFV_TESTS_BRANCH=$2 && download_tst010 |
| 177 | RUN_CONFORMANCE_TESTS=true |
| 178 | shift 1 |
| 179 | ;; |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 180 | -h|--help) |
| 181 | echo "OSM TESTS TOOL |
| 182 | |
| 183 | Usage: |
| 184 | docker run --rm=true -t osmtests --env-file <env_file> \\ |
| Felipe Vicens | 5c54d27 | 2020-06-23 15:55:08 +0200 | [diff] [blame] | 185 | -v <path_to_reports>:/reports osmtests \\ |
| 186 | -v <path_to_clouds.yaml>:/robot-systest/clouds.yaml \\ |
| 187 | -v <path_to_kubeconfig>:/root/.kube/config \\ |
| 188 | -o <osmclient_version> \\ |
| 189 | -p <package_branch> \\ |
| 190 | -t <testing_tags> |
| Felipe Vicens | 6366c68 | 2020-06-25 20:12:16 +0200 | [diff] [blame] | 191 | |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 192 | Options: |
| 193 | --env-file: It is the environmental file where is described the OSM target and VIM |
| 194 | -o <osmclient_version> [OPTIONAL]: It is used to specify a particular osmclient version. Default: latest |
| 195 | -p <package_branch> [OPTIONAL]: OSM packages repository branch. Default: master |
| garciadeblas | 4cf45d7 | 2021-04-08 13:52:22 +0200 | [diff] [blame] | 196 | -t <testing_tags> [OPTIONAL]: Robot tests tags. [sanity, daily, regression, particular_test]. Default: sanity |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 197 | -T <testing_branch> [OPTIONAL]: Run SOL005 Robot conformance tests |
| Mark Beierl | 9e36736 | 2022-12-09 10:20:45 -0500 | [diff] [blame] | 198 | -c To create a VIM and K8s cluster for the tests |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 199 | |
| 200 | Volumes: |
| 201 | <path_to_reports> [OPTIONAL]: It is the absolute path to reports location in the host |
| Felipe Vicens | 5c54d27 | 2020-06-23 15:55:08 +0200 | [diff] [blame] | 202 | <path_to_clouds.yaml> [OPTIONAL]: It is the absolute path to the clouds.yaml file in the host |
| aktas | 8e0504f | 2021-09-06 13:23:35 +0300 | [diff] [blame] | 203 | <path_to_kubeconfig> [OPTIONAL]: It is the kubeconfig file to be used for k8s clusters" |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 204 | |
| 205 | exit 0 |
| 206 | ;; |
| 207 | -*|--*=) |
| 208 | echo "Error: Unsupported flag $1" >&2 |
| 209 | exit 1 |
| 210 | ;; |
| 211 | *) |
| 212 | PARAMS="$PARAMS $1" |
| 213 | shift |
| 214 | ;; |
| 215 | esac |
| 216 | done |
| 217 | |
| 218 | eval set -- "$PARAMS" |
| 219 | |
| Felipe Vicens | 24e3d15 | 2020-06-25 21:52:06 +0200 | [diff] [blame] | 220 | if [[ -n "$BRANCH_NAME" ]]; then |
| 221 | PACKAGES=$BRANCH_NAME && download_packages |
| 222 | OSMCLIENT=$BRANCH_NAME && install_osmclient |
| Felipe Vicens | 6366c68 | 2020-06-25 20:12:16 +0200 | [diff] [blame] | 223 | fi |
| 224 | |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 225 | |
| 226 | if [ "$RUN_CONFORMANCE_TESTS" = true ] ; then |
| 227 | python3 ${ROBOT_DEVOPS_FOLDER}/conformance-tests/run_conformance_tests.py |
| 228 | fi |
| 229 | |
| Felipe Vicens | 6366c68 | 2020-06-25 20:12:16 +0200 | [diff] [blame] | 230 | if [[ -n "${TEST}" ]]; then |
| beierlm | 921c71b | 2022-12-14 19:27:28 +0100 | [diff] [blame] | 231 | robot -d ${ROBOT_DEVOPS_FOLDER}/reports -i ${TEST} ${ROBOT_DEVOPS_FOLDER}/testsuite/ |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 232 | else |
| garciadeblas | 6373cc9 | 2023-05-23 11:17:09 +0200 | [diff] [blame] | 233 | echo "No test was provided. Exiting..." |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 234 | fi |
| 235 | |
| garciadeblas | 6373cc9 | 2023-05-23 11:17:09 +0200 | [diff] [blame] | 236 | exit 0 |